diff --git a/src/main/java/net/minecraft/core/entity/vehicle/MinecartEntity.java b/src/main/java/net/minecraft/core/entity/vehicle/MinecartEntity.java
new file mode 100644
index 000000000..85d4b5a35
--- /dev/null
+++ b/src/main/java/net/minecraft/core/entity/vehicle/MinecartEntity.java
@@ -0,0 +1,827 @@
+package net.minecraft.core.entity.vehicle;
+
+import com.mojang.nbt.CompoundTag;
+import com.mojang.nbt.ListTag;
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.RailBlock;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.logic.RailDirection;
+import net.minecraft.core.crafting.LookupFuelFurnace;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.ItemEntity;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.player.gamemode.Gamemode;
+import net.minecraft.core.player.inventory.container.Container;
+import net.minecraft.core.player.inventory.InventorySorter;
+import net.minecraft.core.util.helper.DamageType;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.phys.Vec3;
+import net.minecraft.core.world.World;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.List;
+
+public class MinecartEntity extends Entity implements Container {
+    public static final int PASSENGER_CART = 0;
+    public static final int CHEST_CART = 1;
+    public static final int FURNACE_CART = 2;
+    // 10 x 2 x 3 table of something
+    private static final int[][][] EXITS = {
+        {
+            {  0,  0, -1 }, // STRAIGHT_NS
+            {  0,  0,  1 }
+        },
+        {
+            { -1,  0,  0 }, // STRAIGHT_EW
+            {  1,  0,  0 }
+        },
+        {
+            { -1, -1,  0 }, // SLOPE_E
+            {  1,  0,  0 }
+        },
+        {
+            { -1,  0,  0 }, // SLOPE_W
+            {  1, -1,  0 }
+        },
+        {
+            {  0,  0, -1 }, // SLOPE_N
+            {  0, -1, 1  }
+        },
+        {
+            {  0, -1, -1 }, // SLOPE_S
+            {  0,  0,  1 }
+        },
+        {
+            {  0,  0,  1 }, // TURN_ES
+            {  1,  0,  0 }
+        },
+        {
+            {  0,  0,  1 }, // TURN_WS
+            { -1,  0,  0 }
+        },
+        {
+            {  0,  0, -1 }, // TURN_WN
+            { -1,  0,  0 }
+        },
+        {
+            {  0,  0, -1 }, // TURN_EN
+            {  1,  0,  0 }
+        }
+    };
+    private ItemStack[] items;
+    public int currentDamage;
+    public int timeSinceHit;
+    public int hurtDirection;
+    public boolean flipped;
+    public int type;
+    public int fuel;
+    public double xPush;
+    public double zPush;
+    private int lerpTicks;
+    private double lerpX;
+    private double lerpY;
+    private double lerpZ;
+    private double lerpYRot;
+    private double lerpXRot;
+    private double lerpXD;
+    private double lerpYD;
+    private double lerpZD;
+
+
+    public MinecartEntity(World world) {
+        super(world);
+        items = new ItemStack[36];
+        currentDamage = 0;
+        timeSinceHit = 0;
+        hurtDirection = 1;
+        flipped = false;
+        blocksBuilding = true;
+        setSize(0.98F, 0.7F);
+        heightOffset = bbHeight / 2.0F;
+    }
+    public MinecartEntity(World world, double x, double y, double z, int type) {
+        this(world);
+        setPos(x, y + (double) heightOffset, z);
+        xd = 0.0D;
+        yd = 0.0D;
+        zd = 0.0D;
+        xo = x;
+        yo = y;
+        zo = z;
+        this.type = type;
+    }
+    @Override
+    public float getShadowHeightOffs() {
+        return 0.0F;
+    }
+    @Override
+	protected boolean makeStepSound() {
+        return false;
+    }
+    @Override
+	protected void defineSynchedData() {
+    }
+    @Override
+	public boolean isPushable() {
+        return true;
+    }
+    @Override
+    public boolean isPickable() {
+        return !removed;
+    }
+    @Override
+    public double getRideHeight() {
+        return (double) bbHeight * 0.0D - 0.3D;
+    }
+
+    @Override
+    public Entity ejectRider() {
+        Entity entity = passenger;
+        if (entity == null) return null;
+
+        this.passenger = null;
+        entity.vehicle = null;
+
+        int blockX = MathHelper.floor(this.x);
+        int blockY = MathHelper.floor(this.y);
+        int blockZ = MathHelper.floor(this.z);
+
+        if (isSafe(blockX - 1, blockY, blockZ)) {
+            entity.moveTo(blockX - 0.5, blockY, blockZ + 0.5, entity.yRot, entity.xRot);
+        } else if (isSafe(blockX + 1, blockY, blockZ)) {
+            entity.moveTo(blockX + 1.5, blockY, blockZ + 0.5, entity.yRot, entity.xRot);
+        } else if (isSafe(blockX, blockY, blockZ - 1)) {
+            entity.moveTo(blockX + 0.5, blockY, blockZ - 0.5, entity.yRot, entity.xRot);
+        } else if (isSafe(blockX, blockY, blockZ + 1)) {
+            entity.moveTo(blockX + 0.5, blockY, blockZ + 1.5, entity.yRot, entity.xRot);
+        } else {
+            entity.moveTo(blockX + 0.5, blockY + 1, blockZ + 0.5, entity.yRot, entity.xRot);
+        }
+
+        return entity;
+    }
+
+    private boolean isSafe(int x, int y, int z) {
+        return !world.isBlockNormalCube(x, y, z) && !world.isBlockNormalCube(x, y + 1, z);
+    }
+
+    @Override
+    public boolean hurt(Entity entity, int baseDamage, DamageType type) {
+        if(world.isClientSide || removed) {
+            return true;
+        }
+        if(entity instanceof Player) {
+        	if(((Player) entity).getGamemode() == Gamemode.creative) {
+        		remove();
+        		return true;
+        	}
+        }
+        hurtDirection = -hurtDirection;
+        timeSinceHit = 10;
+        markHurt();
+        currentDamage += baseDamage * 10;
+        if(currentDamage > 40) {
+            if(passenger != null) {
+                passenger.startRiding(this);
+            }
+            if (!world.isClientSide){
+                spawnAtLocation(Items.MINECART.id, 1, 0.0F);
+                switch (this.type){
+                    case CHEST_CART:
+                        spawnAtLocation(Blocks.CHEST_PLANKS_OAK.id, 1, 0.0F);
+                        break;
+                    case FURNACE_CART:
+                        spawnAtLocation(Blocks.FURNACE_STONE_IDLE.id, 1, 0.0F);
+                        break;
+                }
+            }
+            remove();
+        }
+        return true;
+    }
+
+    @Override
+	public void animateHurt() {
+        hurtDirection = -hurtDirection;
+        timeSinceHit = 10;
+        currentDamage += currentDamage * 10;
+    }
+
+    @Override
+	public void remove() {
+        if (!world.isClientSide){
+            for(int j = 0; j < this.getContainerSize(); j++) {
+                ItemStack itemStack = this.getItem(j);
+                if(itemStack == null) continue;
+
+                final float range = 0.7F;
+                double x1 = (double) (random.nextFloat() * range) + (double) (1.0F - range) * 0.5D;
+                double y1 = (double) (random.nextFloat() * range) + (double) (1.0F - range) * 0.5D;
+                double z1 = (double) (random.nextFloat() * range) + (double) (1.0F - range) * 0.5D;
+                ItemEntity itemEntity = new ItemEntity(world, x + x1, y + y1, z + z1, itemStack);
+                itemEntity.pickupDelay = 10;
+                world.entityJoinedWorld(itemEntity);
+                itemEntity.xd *= 0.5;
+                itemEntity.yd *= 0.5;
+                itemEntity.zd *= 0.5;
+                itemEntity.pickupDelay = 0;
+            }
+        }
+
+        ejectRider();
+        super.remove();
+    }
+
+    @Override
+	public void tick() {
+        if(timeSinceHit > 0) timeSinceHit--;
+        if(currentDamage > 0) currentDamage--;
+
+        double _xo = x;
+        double _yo = y;
+        double _zo = z;
+        float _yRot = yRot;
+        float _xRot = xRot;
+        if (world.isClientSide){
+            if (lerpTicks > 0){
+                double newX = x + (lerpX - x) / (double) lerpTicks;
+                double newY = y + (lerpY - y) / (double) lerpTicks;
+                double newZ = z + (lerpZ - z) / (double) lerpTicks;
+
+                yRot += (float) (MathHelper.normalizeRotation(lerpYRot - (double) yRot) / lerpTicks);
+                xRot += (float) (MathHelper.normalizeRotation(lerpXRot - (double) xRot) / lerpTicks);
+
+                lerpTicks--;
+                setPos(newX, newY, newZ);
+                setRot(yRot, xRot);
+            }
+        } else {
+            motionIteration();
+            motionIteration();
+        }
+        this.xo = _xo;
+        this.yo = _yo;
+        this.zo = _zo;
+        this.yRotO = _yRot;
+        this.xRotO = _xRot;
+    }
+
+    public void motionIteration() {
+        xo = x;
+        yo = y;
+        zo = z;
+        yd -= 0.04D;
+        int blockX = MathHelper.floor(x);
+        int blockY = MathHelper.floor(y);
+        int blockZ = MathHelper.floor(z);
+        if(RailBlock.isRailBlockAt(world, blockX, blockY - 1, blockZ)) {
+            blockY--;
+        }
+        final double maxSpeed = 0.4D;
+        boolean didFurnacePush = false;
+        final double d5 = 0.0078125D;
+        Block block = world.getBlock(blockX, blockY, blockZ);
+        if(block instanceof RailBlock) {
+            RailBlock rail = (RailBlock) block;
+            Vec3 vec3d = getPos(x, y, z);
+            y = blockY;
+            boolean onPoweredPoweredRail = false;
+            boolean onUnpoweredPoweredRail = false;
+            if(rail.isPowered) {
+                onPoweredPoweredRail = (world.getBlockMetadata(blockX, blockY, blockZ) & 0b1000) != 0;
+                onUnpoweredPoweredRail = !onPoweredPoweredRail;
+            }
+            RailDirection railDirection = rail.getRailDirection(world, blockX, blockY, blockZ);
+
+            if(railDirection.isSloped()) {
+                y = blockY + 1;
+            }
+            if(railDirection == RailDirection.SLOPE_E) {
+                xd -= d5;
+            }
+            if(railDirection == RailDirection.SLOPE_W) {
+                xd += d5;
+            }
+            if(railDirection == RailDirection.SLOPE_N) {
+                zd += d5;
+            }
+            if(railDirection == RailDirection.SLOPE_S) {
+                zd -= d5;
+            }
+            int[][] nextRailTable = EXITS[railDirection.meta];
+            double d9 = nextRailTable[1][0] - nextRailTable[0][0];
+            double d10 = nextRailTable[1][2] - nextRailTable[0][2];
+            double d11 = Math.sqrt(d9 * d9 + d10 * d10);
+            double d12 = xd * d9 + zd * d10;
+            if(d12 < 0.0D) {
+                d9 = -d9;
+                d10 = -d10;
+            }
+
+            double vel = Math.hypot(xd, zd);
+            xd = (vel * d9) / d11;
+            zd = (vel * d10) / d11;
+            if(onUnpoweredPoweredRail) { // Speed penalty
+                // If current speed below threshold kill all motion
+                if(Math.hypot(xd, zd) < 0.03D) {
+                    xd *= 0.0D;
+                    yd *= 0.0D;
+                    zd *= 0.0D;
+                } else {
+                    xd *= 0.5D;
+                    yd *= 0.0D;
+                    zd *= 0.5D;
+                }
+            }
+            double d18 = (double)blockX + 0.5D + (double)nextRailTable[0][0] * 0.5D;
+            double d19 = (double)blockZ + 0.5D + (double)nextRailTable[0][2] * 0.5D;
+            double d20 = (double)blockX + 0.5D + (double)nextRailTable[1][0] * 0.5D;
+            double d21 = (double)blockZ + 0.5D + (double)nextRailTable[1][2] * 0.5D;
+            d9 = d20 - d18;
+            d10 = d21 - d19;
+            double d17;
+            if(d9 == 0.0D) {
+                d17 = z - (double)blockZ;
+            } else if(d10 == 0.0D) {
+                d17 = x - (double)blockX;
+            } else {
+                double d22 = x - d18;
+                double d24 = z - d19;
+                d17 = (d22 * d9 + d24 * d10) * 2D;
+            }
+            x = d18 + d9 * d17;
+            z = d19 + d10 * d17;
+            setPos(x, y + (double) heightOffset, z);
+
+            // Let passenger push minecart slowly
+            if(passenger != null && Math.hypot(xd, zd) < 0.01f) {
+                xd += passenger.xd * 0.05;
+                zd += passenger.zd * 0.05;
+            }
+            double _xd = xd;
+            double _zd = zd;
+            if(passenger != null) {
+                _xd *= 0.75D;
+                _zd *= 0.75D;
+            }
+            // Cap speed
+            _xd = MathHelper.clamp(_xd, -maxSpeed, maxSpeed);
+            _zd = MathHelper.clamp(_zd, -maxSpeed, maxSpeed);
+
+            move(_xd, 0.0D, _zd);
+            if(nextRailTable[0][1] != 0 && MathHelper.floor(x) - blockX == nextRailTable[0][0] && MathHelper.floor(z) - blockZ == nextRailTable[0][2]) {
+                setPos(x, y + (double)nextRailTable[0][1], z);
+            } else if(nextRailTable[1][1] != 0 && MathHelper.floor(x) - blockX == nextRailTable[1][0] && MathHelper.floor(z) - blockZ == nextRailTable[1][2]) {
+                setPos(x, y + (double)nextRailTable[1][1], z);
+            }
+            if(passenger != null) {
+                xd *= 0.997D;
+                yd *= 0.0D;
+                zd *= 0.997D;
+            } else {
+                if(type == FURNACE_CART) {
+                    vel = Math.hypot(xPush, zPush);
+                    if(vel > 0.01D) {
+                        didFurnacePush = true;
+                        xPush /= vel;
+                        zPush /= vel;
+                        xd *= 0.8D;
+                        yd *= 0.0D;
+                        zd *= 0.8D;
+                        final double pushScalar = 0.04D;
+                        xd += xPush * pushScalar;
+                        zd += zPush * pushScalar;
+                    } else {
+                        xd *= 0.9D;
+                        yd *= 0.0D;
+                        zd *= 0.9D;
+                    }
+                }
+                xd *= 0.96D;
+                yd *= 0.0D;
+                zd *= 0.96D;
+            }
+            Vec3 vec3d1 = getPos(x, y, z);
+            if(vec3d1 != null && vec3d != null) {
+                double slopeSpeedOffset = (vec3d.y - vec3d1.y) * 0.05D; // I think this give a speed buff/penalty for going up/down slopes
+                vel = Math.hypot(xd, zd);
+                if(vel > 0.0D) {
+                    xd = (xd / vel) * (vel + slopeSpeedOffset);
+                    zd = (zd / vel) * (vel + slopeSpeedOffset);
+                }
+                setPos(x, vec3d1.y, z);
+            }
+            int newBlockX = MathHelper.floor(x);
+            int newBlockZ = MathHelper.floor(z);
+            if(newBlockX != blockX || newBlockZ != blockZ) {
+                vel = Math.hypot(xd, zd);
+                xd = vel * (double)(newBlockX - blockX);
+                zd = vel * (double)(newBlockZ - blockZ);
+            }
+            if(type == FURNACE_CART) {
+                double pushMagnitude = Math.hypot(xPush, zPush);
+                if(pushMagnitude > 0.01D && Math.hypot(xd, zd) > 0.001D) {
+                    xPush = xd;
+                    zPush = zd;
+                }
+            }
+            if(onPoweredPoweredRail) { // Speed boost
+                vel = Math.hypot(xd, zd);
+                if(vel > 0.01D) {
+                    final double scalar = 0.06D;
+                    xd += (xd / vel) * scalar;
+                    zd += (zd / vel) * scalar;
+                } else if(railDirection == RailDirection.STRAIGHT_EW) {
+                    if(world.isBlockNormalCube(blockX - 1, blockY, blockZ)) {
+                        xd = 0.02D;
+                    } else if(world.isBlockNormalCube(blockX + 1, blockY, blockZ)) {
+                        xd = -0.02D;
+                    }
+                } else if(railDirection == RailDirection.STRAIGHT_NS) {
+                    if(world.isBlockNormalCube(blockX, blockY, blockZ - 1)) {
+                        zd = 0.02D;
+                    } else if(world.isBlockNormalCube(blockX, blockY, blockZ + 1)) {
+                        zd = -0.02D;
+                    }
+                }
+            }
+        } else {
+            xd = MathHelper.clamp(xd, -maxSpeed, maxSpeed);
+            zd = MathHelper.clamp(zd, -maxSpeed, maxSpeed);
+
+            if(onGround) {
+                xd *= 0.5D;
+                yd *= 0.5D;
+                zd *= 0.5D;
+            }
+            move(xd, yd, zd);
+            if(!onGround) {
+                xd *= 0.95D;
+                yd *= 0.95D;
+                zd *= 0.95D;
+            }
+        }
+        xRot = 0.0F;
+        double diffX = xo - x;
+        double diffZ = zo - z;
+        if(Math.hypot(diffX, diffZ) > 0.001D) {
+            yRot = (float) Math.toDegrees(Math.atan2(diffZ, diffX));
+            if(flipped) {
+                yRot += 180F;
+            }
+        }
+
+        double diffYRot = MathHelper.normalizeRotation(yRot - yRotO);
+
+        // Cause minecart to flip 180?
+        if(diffYRot < -170D || diffYRot >= 170D) {
+            yRot += 180F;
+            flipped = !flipped;
+        }
+
+        setRot(yRot, xRot);
+        List<Entity> list = world.getEntitiesWithinAABBExcludingEntity(this, bb.expand(0.2D, 0.0D, 0.2));
+        if(list != null && !list.isEmpty()) {
+            for (Entity entity : list) {
+                if ((entity instanceof MinecartEntity) && entity != passenger && entity.isPushable()) {
+                    entity.push(this);
+                }
+            }
+        }
+        if(passenger != null && passenger.removed) {
+            passenger = null;
+        }
+        if(didFurnacePush && random.nextInt(4) == 0) {
+            fuel--;
+            if(fuel < 0) {
+                xPush = 0.0D;
+                zPush = 0.0D;
+            }
+            world.spawnParticle("largesmoke", x, y + 0.8D, z, 0.0D, 0.0D, 0.0D, 0);
+        }
+    }
+
+    public Vec3 getPosOffs(final double x, final double y, final double z, final double scalar /*Not sure what this is for still*/) {
+        int blockX = MathHelper.floor(x);
+        int blockY = MathHelper.floor(y);
+        int blockZ = MathHelper.floor(z);
+        if(RailBlock.isRailBlockAt(world, blockX, blockY - 1, blockZ)) {
+            blockY--;
+        }
+
+        Block block = world.getBlock(blockX, blockY, blockZ);
+        if (!(block instanceof RailBlock)) { return null; }
+
+        RailBlock rail = (RailBlock) block;
+        int meta = world.getBlockMetadata(blockX, blockY, blockZ);
+        if(rail.getIsPowered()) {
+            meta &= 0b111;
+        }
+        if(meta >= 2 && meta <= 5) {
+            blockY += 1;
+        }
+        int[][] ai = EXITS[meta];
+        double d4 = ai[1][0] - ai[0][0];
+        double d5 = ai[1][2] - ai[0][2];
+        double d6 = Math.sqrt(d4 * d4 + d5 * d5);
+        d4 /= d6;
+        d5 /= d6;
+        double vecX = x + d4 * scalar;
+        double vecZ = z + d5 * scalar;
+        double vecY = blockY;
+        if(ai[0][1] != 0 && MathHelper.floor(x) - blockX == ai[0][0] && MathHelper.floor(z) - blockZ == ai[0][2]) {
+            vecY += ai[0][1];
+        } else if(ai[1][1] != 0 && MathHelper.floor(x) - blockX == ai[1][0] && MathHelper.floor(z) - blockZ == ai[1][2]) {
+            vecY += ai[1][1];
+        }
+        return getPos(vecX, vecY, vecZ);
+    }
+    /**
+     * @return null if not on rail otherwise ?
+     */
+    // If this gets fucked up then the animation looks wrong?
+    @Nullable
+    public Vec3 getPos(final double x, final double y, final double z) {
+        int blockX = MathHelper.floor(x);
+        int blockY = MathHelper.floor(y);
+        int blockZ = MathHelper.floor(z);
+
+        if(RailBlock.isRailBlockAt(world, blockX, blockY - 1, blockZ)) {
+            blockY--;
+        }
+        Block block = world.getBlock(blockX, blockY, blockZ);
+        if (!(block instanceof RailBlock)) { return null; }
+
+        RailBlock rail = (RailBlock) block;
+        RailDirection direction = rail.getRailDirection(world, blockX, blockY, blockZ);
+
+        int[][] offsetMap = EXITS[direction.meta];
+        double x1 = (double)blockX + 0.5D + (double)offsetMap[0][0] * 0.5D;
+        double y1 = (double)blockY + 0.5D + (double)offsetMap[0][1] * 0.5D;
+        double z1 = (double)blockZ + 0.5D + (double)offsetMap[0][2] * 0.5D;
+        double x2 = (double)blockX + 0.5D + (double)offsetMap[1][0] * 0.5D;
+        double y2 = (double)blockY + 0.5D + (double)offsetMap[1][1] * 0.5D;
+        double z2 = (double)blockZ + 0.5D + (double)offsetMap[1][2] * 0.5D;
+
+        double railsDX = x2 - x1;
+        double railsDY = (y2 - y1) * 2D;
+        double railsDZ = z2 - z1;
+
+        double proximity; // ?
+        if(railsDX == 0.0D) { // If rail axis is aligned NorthSouth
+            proximity = z - (double)blockZ;
+        } else if(railsDZ == 0.0D) { // If rail axis is aligned EastWest
+            proximity = x - (double)blockX;
+        } else { // If Rail Curves?
+            double targetDX = x - x1;
+            double targetDZ = z - z1;
+            proximity = (targetDX * railsDX + targetDZ * railsDZ) * 2D;
+        }
+
+        double vecX = x1 + railsDX * proximity;
+        double vecY = y1 + railsDY * proximity;
+        double vecZ = z1 + railsDZ * proximity;
+        if(railsDY < 0.0D) {
+            vecY++;
+        }
+
+        if(railsDY > 0.0D) {
+            vecY += 0.5D;
+        }
+        return Vec3.getTempVec3(vecX, vecY, vecZ);
+    }
+
+    @Override
+    public void lerpTo(double x, double y, double z, float yRot, float xRot, int ticks) {
+        lerpX = x;
+        lerpY = y;
+        lerpZ = z;
+        lerpYRot = yRot;
+        lerpXRot = xRot;
+        lerpTicks = 2;
+        xd = lerpXD;
+        yd = lerpYD;
+        zd = lerpZD;
+    }
+
+    @Override
+    public void lerpMotion(double xd, double yd, double zd) {
+        lerpXD = this.xd = xd;
+        lerpYD = this.yd = yd;
+        lerpZD = this.zd = zd;
+    }
+
+    @Override
+	public void push(Entity entity) {
+        if(world.isClientSide) {
+            return;
+        }
+        if(entity == passenger) {
+            return;
+        }
+        if(!entity.isPushable()) {
+        	return;
+        }
+        if(type == PASSENGER_CART && (entity instanceof Mob) && !(entity instanceof Player) && xd * xd + zd * zd > 0.01D && passenger == null && entity.vehicle == null) {
+            entity.startRiding(this);
+        }
+        final double diffX = entity.x - this.x;
+        final double diffZ = entity.z - this.z;
+        final double distSqr = diffX * diffX + diffZ * diffZ;
+        if (distSqr >= 0.0001) {
+            final double distance = Math.sqrt(distSqr);
+            final double unitX = diffX / distance;
+            final double unitZ = diffZ / distance;
+            double n7 = 1.0 / distance;
+            if (n7 > 1.0) {
+                n7 = 1.0;
+            }
+            final double n8 = unitX * n7;
+            final double n9 = unitZ * n7;
+            final double n10 = n8 * 0.1;
+            final double n11 = n9 * 0.1;
+            final double n12 = n10 * (1.0f - this.pushthrough);
+            final double n13 = n11 * (1.0f - this.pushthrough);
+            final double xForce = n12 * 0.5;
+            final double zForce = n13 * 0.5;
+            if (entity instanceof MinecartEntity) {
+                if (((MinecartEntity)entity).type == FURNACE_CART && this.type != FURNACE_CART) {
+                    this.xd *= 0.2;
+                    this.zd *= 0.2;
+                    this.push(entity.xd - xForce, 0.0, entity.zd - zForce);
+                    entity.xd *= 0.7;
+                    entity.zd *= 0.7;
+                }
+                else if (((MinecartEntity)entity).type != FURNACE_CART && this.type == FURNACE_CART) {
+                    entity.xd *= 0.2;
+                    entity.zd *= 0.2;
+                    entity.push(this.xd + xForce, 0.0, this.zd + zForce);
+                    this.xd *= 0.7;
+                    this.zd *= 0.7;
+                }
+                else {
+                    final double avgXD = (entity.xd + this.xd) / 2.0;
+                    final double avgZD = (entity.zd + this.zd) / 2.0;
+                    this.xd *= 0.2;
+                    this.zd *= 0.2;
+                    this.push(avgXD - xForce, 0.0, avgZD - zForce);
+                    entity.xd *= 0.2;
+                    entity.zd *= 0.2;
+                    entity.push(avgXD + xForce, 0.0, avgZD + zForce);
+                }
+            }
+            else {
+                this.push(-xForce, 0.0, -zForce);
+                entity.push(xForce / 4.0, 0.0, zForce / 4.0);
+            }
+        }
+    }
+
+    @Override
+    public boolean stillValid(Player player) {
+        if(isRemoved()) {
+            return false;
+        }
+        return player.distanceToSqr(this) <= 64D; // Can interact within 8 blocks
+    }
+
+    @Override
+	public boolean interact(Player player) {
+        switch (type){
+            case PASSENGER_CART:
+                if(passenger != null && (passenger instanceof Player) && passenger != player) {
+                    return true;
+                }
+                if(!world.isClientSide) {
+                    player.startRiding(this);
+                }
+                break;
+            case CHEST_CART:
+                if(!world.isClientSide) {
+                    player.displayGUIChest(this);
+                }
+                break;
+            case FURNACE_CART:
+                ItemStack itemstack = player.inventory.getCurrentItem();
+                if(itemstack != null && LookupFuelFurnace.instance.getFuelYield(itemstack.itemID) > 0) {
+                    if(--itemstack.stackSize <= 0)
+                    {
+                        player.inventory.setItem(player.inventory.currentItem, null);
+                    }
+                    fuel += (int) ((LookupFuelFurnace.instance.getFuelYield(itemstack.itemID)/1600F) * 1200);
+                }
+                xPush = x - player.x;
+                zPush = z - player.z;
+                break;
+        }
+        return true;
+    }
+
+    @Override
+    public void addAdditionalSaveData(CompoundTag tag) {
+        tag.putInt("Type", type);
+        switch (type){
+            case CHEST_CART:
+                ListTag nbttaglist = new ListTag();
+                for(int i = 0; i < items.length; i++) {
+                    if(items[i] != null) {
+                        CompoundTag nbttagcompound1 = new CompoundTag();
+                        nbttagcompound1.putByte("Slot", (byte)i);
+                        items[i].writeToNBT(nbttagcompound1);
+                        nbttaglist.addTag(nbttagcompound1);
+                    }
+                }
+                tag.put("Items", nbttaglist);
+                break;
+            case FURNACE_CART:
+                tag.putDouble("PushX", xPush);
+                tag.putDouble("PushZ", zPush);
+                tag.putShort("Fuel", (short)fuel);
+                break;
+        }
+    }
+
+    @Override
+    public void readAdditionalSaveData(CompoundTag tag) {
+        type = tag.getInteger("Type");
+        switch (type){
+            case CHEST_CART:
+                ListTag nbttaglist = tag.getList("Items");
+                items = new ItemStack[getContainerSize()];
+                for(int i = 0; i < nbttaglist.tagCount(); i++) {
+                    CompoundTag nbttagcompound1 = (CompoundTag)nbttaglist.tagAt(i);
+                    int j = nbttagcompound1.getByte("Slot") & 0xff;
+                    if(j < items.length) {
+                        items[j] = ItemStack.readItemStackFromNbt(nbttagcompound1);
+                    }
+                }
+                break;
+            case FURNACE_CART:
+                xPush = tag.getDouble("PushX");
+                zPush = tag.getDouble("PushZ");
+                fuel = tag.getShort("Fuel");
+                break;
+        }
+    }
+    // Inventory Stuff
+
+
+    @Override
+    public String getName() {
+        return "Minecart";
+    }
+
+    @Override
+    public int getMaxStackSize() {
+        return 64;
+    }
+
+    @Override
+    public int getContainerSize() {
+        return 27;
+    }
+
+    @Override
+    public ItemStack getItem(int index) {
+        return items[index];
+    }
+
+    @Override
+    public ItemStack removeItem(int index, int takeAmount) {
+        if(items[index] != null) {
+            if(items[index].stackSize <= takeAmount) {
+                ItemStack itemstack = items[index];
+                items[index] = null;
+                return itemstack;
+            }
+            ItemStack itemstack1 = items[index].splitStack(takeAmount);
+            if(items[index].stackSize <= 0) {
+                items[index] = null;
+            }
+            return itemstack1;
+        } else {
+            return null;
+        }
+    }
+
+    @Override
+    public void setItem(int index, ItemStack itemstack) {
+        items[index] = itemstack;
+        if(itemstack != null && itemstack.stackSize > getMaxStackSize()) {
+            itemstack.stackSize = getMaxStackSize();
+        }
+    }
+
+    @Override
+    public void setChanged() {
+    }
+
+    @Override
+    public void sortContainer() {
+        InventorySorter.sortInventory(items);
+    }
+
+}
